import java.util.Iterator;

ArrayList<Particle> particles;
ArrayList<Zombie> zombies;
int particleSize;


void setup(){
  size(1280,720);
  frameRate(30);
  background(255);
  particles = new ArrayList<Particle>();
  zombies = new ArrayList<Zombie>();
  particleSize = 5;
  
  for (int i=0;i<particleSize;i++){
    particles.add(new Particle());
  }
    zombies.add(new Zombie());
}

void draw(){
  background(255);
  Iterator<Particle> it = particles.iterator();
  while(it.hasNext()){
    Particle p = it.next();
    p.run();
    if(p.isDead()){
      it.remove();
    }
  }
  
  if(particles.size() <particleSize){
    zombies.add(new Zombie());
    particleSize -= 1;
  }
  for(Zombie z:zombies){
    z.run();
    for(Particle p:particles){
      PVector forceRepel = p.repel(z);
      p.applyForce(forceRepel);
      PVector forceAttract = z.attract(p);
      z.applyForce(forceAttract);
      PVector difference = PVector.sub(z.location,p.location);
      if(difference.mag()<20){
        p.lifespan = -2;
      }
    }
  }
}

void mouseClicked(){
  particles.add(new Particle());
  particleSize+=1;
}

